package io.gitlab.jfronny.inceptum.gson;

import com.google.gson.*;
import com.google.gson.reflect.TypeToken;
import io.gitlab.jfronny.inceptum.model.inceptum.source.ModSource;

import java.lang.reflect.Type;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Optional;

public class ModSourceMapDeserializer implements JsonSerializer<Map<ModSource, Optional<ModSource>>>, JsonDeserializer<Map<ModSource, Optional<ModSource>>> {
    public static final Type modSourceMapType = new TypeToken<Map<ModSource, Optional<ModSource>>>(){}.getType();
    @Override
    public Map<ModSource, Optional<ModSource>> deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
        if (!json.isJsonArray()) throw new JsonParseException("Not an array");
        Map<ModSource, Optional<ModSource>> res = new LinkedHashMap<>();
        for (JsonElement element : json.getAsJsonArray()) {
            res.put(context.deserialize(element, ModSource.class), Optional.empty());
        }
        return res;
    }

    @Override
    public JsonElement serialize(Map<ModSource, Optional<ModSource>> src, Type typeOfSrc, JsonSerializationContext context) {
        JsonArray res = new JsonArray();
        for (ModSource source : src.keySet()) {
            res.add(context.serialize(source, ModSource.class));
        }
        return res;
    }
}
