package io.gitlab.jfronny.inceptum.install.steps;

import io.gitlab.jfronny.inceptum.Inceptum;
import io.gitlab.jfronny.inceptum.install.SetupStepInfo;
import io.gitlab.jfronny.inceptum.install.Step;
import io.gitlab.jfronny.inceptum.model.mojang.AssetIndex;
import io.gitlab.jfronny.inceptum.util.api.McApi;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Map;
import java.util.concurrent.atomic.AtomicBoolean;

public class DownloadAssetsStep implements Step {
    @Override
    public void execute(SetupStepInfo info, AtomicBoolean stopThread) throws IOException {
        Path o = Inceptum.ASSETS_DIR.resolve("objects");
        for (Map.Entry<String, AssetIndex.Asset> entry : McApi.getAssetIndex(info.version()).objects.entrySet()) {
            if (stopThread.get()) return;
            Path fPath = o.resolve(entry.getValue().hash.substring(0, 2));
            if (!Files.exists(fPath)) Files.createDirectories(fPath);
            fPath = fPath.resolve(entry.getValue().hash);
            if (Files.exists(fPath)) continue;
            info.setState("Downloading asset: " + entry.getKey());
            McApi.downloadAsset(entry.getValue(), fPath);
        }
    }
}
