package io.gitlab.jfronny.inceptum.model.curseforge;

import java.util.List;

public class CurseforgeMod {
    public Integer id;
    public String name;
    public List<Author> authors;
    public List<Attachment> attachments;
    public String issueTrackerUrl;
    public String wikiUrl;
    public String sourceUrl;
    public String websiteUrl;
    public Integer gameId;
    public String summary;
    public Integer downloadFiles;
    public Integer downloadCount;
    public List<File> latestFiles;
    public List<Category> categories;
    public Integer statue;
    public Integer primaryCategoryId;
    public CategorySection categorySection;
    public String slug;
    public List<GameVersionLatestFile> gameVersionLatestFiles;
    public Boolean isFeatured;
    public Float popularityScore;
    public Integer gamePopularityRank;
    public String primaryLanguage;
    public String gameSlug;
    public List<String> modLoaders;
    public String gameName;
    public String portalName;
    //public Date dateModified;
    //public Date dateCreated;
    //public Date dateReleased;
    public Boolean isAvailable;
    public Boolean isExperimental;

    public static class Author {
        public String name;
        public String url;
        public Integer projectId;
        public Integer id;
        public Integer userId;
        public Integer twitchId;
    }

    public static class Attachment {
        public Integer id;
        public Integer projectId;
        public String description;
        public Boolean isDefault;
        public String thumbnailUrl;
        public String title;
        public String url;
        public Integer status;
    }

    public static class File {
        public Integer id;
        public String displayName;
        public String fileName;
        //public Date fileDate;
        public Integer fileLength;
        public Integer releaseType;
        public Integer fileStatus;
        public String downloadUrl;
        public Boolean isAlternate;
        public Integer alternatFileId;
        public List<CurseforgeDependency> dependencies;
        public Boolean isAvailable;
        public List<CurseforgeModule> modules;
        public Long packageFingerprint;
        public List<String> gameVersion;
        public List<SortableGameVersion> sortableGameVersion;
        public String changelog;
        public Boolean hasInstallScript;
        public Boolean isCompatibleWithClient;
        public Integer categorySectionPackageType;
        public Integer restrictProjectFileAccess;
        public Integer projectStatus;
        public Integer renderCacheId;
        public Integer projectId;
        public Long packageFingerprintId;
        //public Date gameVersionDateReleased;
        public Long gameVersionMappingId;
        public Integer gameVersionId;
        public Integer gameId;
        public Boolean isServerPack;
        public List<Hash> hashes;

        public static class SortableGameVersion {
            public String gameVersionPadded;
            public String gameVersion;
            //public Date gameVersionReleaseDate;
            public String gameVersionName;
            public Integer gameVersionTypeId;
        }

        public static class Hash {
            public Integer algorithm;
            public String value;
        }
    }

    public static class Category {
        public Integer categoryId;
        public String name;
        public String url;
        public String avatarUrl;
        public Integer parentId;
        public Integer rootId;
        public Integer projectId;
        public Integer avatarId;
        public Integer gameId;
        public String slug;
        //public Date dateModified;
    }

    public static class CategorySection {
        public Integer id;
        public Integer gameId;
        public String name;
        public Integer packageType;
        public String path;
        public String initialInclusionPattern;
        public Integer gameCategoryId;
    }

    public static class GameVersionLatestFile {
        public String gameVersion;
        public Integer projectFileId;
        public String projectFileName;
        public Integer fileType;
        public Integer gameVersionTypeId;
    }
}
