package io.gitlab.jfronny.inceptum.model.fabric;

import java.util.List;

public class FabricVersionLoaderInfo {
    public FabricLoaderVersion loader;
    public IntermediaryVersion intermediary;

    public static class WithMeta extends FabricVersionLoaderInfo {
        public LauncherMeta launcherMeta;

        public static class LauncherMeta {
            public int version;
            public Libraries libraries;
            public MainClass mainClass;

            public static class Libraries {
                public List<Library> client;
                public List<Library> common;
                public List<Library> server;

                public static class Library {
                    public String name;
                    public String url;
                }
            }

            public static class MainClass {
                public String client;
                public String server;
            }
        }
    }
}
