package io.gitlab.jfronny.inceptum.model.inceptum;

import io.gitlab.jfronny.inceptum.gson.GsonIgnore;

import java.util.List;

public class InstanceMeta {
    @GsonIgnore public static final String floaderPrefix = "fabric-loader-";
    public String version;
    public String java;
    public Long minMem;
    public Long maxMem;
    public Arguments arguments; //TODO allow configuring in UI

    public boolean isFabric() {
        return version.startsWith(floaderPrefix);
    }

    public String getMinecraftVersion() {
        return getMinecraftVersion(version);
    }

    public static String getMinecraftVersion(String id) {
        return id.startsWith(floaderPrefix) ? id.substring(id.lastIndexOf('-') + 1) : id;
    }

    public String getLoaderVersion() {
        return isFabric() ? version.substring(floaderPrefix.length()).split("-")[0] : "";
    }

    public static class Arguments {
        public List<String> jvm;
        public List<String> client;
        public List<String> server;
    }
}
