package io.gitlab.jfronny.inceptum.model.inceptum.source;

import io.gitlab.jfronny.inceptum.Inceptum;

import java.io.IOException;
import java.nio.file.Path;
import java.util.Optional;
import java.util.Set;

public interface ModSource {
    ModDownload download() throws IOException;
    Set<ModSource> getDependencies() throws IOException;
    Optional<ModSource> getUpdate(String gameVersion) throws IOException;
    String getVersion();
    String getName();
    String getFileName();
    boolean equals(ModSource other);
    default Path getJarPath() {
        return Inceptum.LIBRARIES_DIR.resolve("com").resolve(getName()).resolve(getFileName());
    }
}
