package io.gitlab.jfronny.inceptum.model.modrinth;

import java.util.Date;
import java.util.List;

public class ModrinthVersion {
    public String id;
    public String mod_id;
    public String author_id;
    public Boolean featured;
    public String name;
    public String version_number;
    public String changelog;
    public Date date_published;
    public Integer downloads;
    public VersionType version_type;
    public List<File> files;
    public List<Dependency> dependencies;
    public List<String> game_versions;
    public List<String> loaders;

    public enum VersionType {
        alpha, beta, release
    }

    public static class File {
        public Hashes hashes;
        public String url;
        public String filename;
        public Boolean primary;

        public static class Hashes {
            public String sha512;
            public String sha1;
        }
    }

    public static class Dependency {
        public String version_id;
        public DependencyType dependency_type;

        public enum DependencyType {
            required,
            optional,
            incompatible
        }
    }
}
