package io.gitlab.jfronny.inceptum.model.mojang;

import java.util.List;
import java.util.Map;

public class VersionInfo extends VersionsListInfo {
    public Arguments arguments;
    public AssetIndex assetIndex;
    public String assets;
    public Downloads downloads;
    public JavaVersion javaVersion;
    public List<Library> libraries;
    public String mainClass;
    public String minecraftArguments;
    public Integer minimumLauncherVersion;

    public static class Arguments {
        public List<MinecraftArgument> game;
        public List<MinecraftArgument> jvm;
    }

    public static class AssetIndex extends MojangFileDownload {
        public String id;
        public int totalSize;
    }

    public static class Downloads {
        public MojangFileDownload client;
        public MojangFileDownload client_mappings;
        public MojangFileDownload server;
        public MojangFileDownload server_mappings;
    }

    public static class JavaVersion {
        public String component;
        public int majorVersion;
    }

    public static class Library {
        public Downloads downloads;
        public String name;
        public Map<String, String> natives;
        public Rules rules;

        public static class Downloads {
            public Artifact artifact;
            public Map<String, Artifact> classifiers;

            public static class Artifact extends MojangFileDownload {
                public String path;
            }
        }
    }

    public static class Logging {
        public Client client;

        public static class Client {
            public String argument;
            public Library.Downloads.Artifact file;
            public String type;
        }
    }
}
