package io.gitlab.jfronny.inceptum.util;

import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.AppenderBase;

import java.time.Instant;
import java.util.LinkedHashSet;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

public class MapAppender extends AppenderBase<ILoggingEvent> {
    public static final ConcurrentMap<String, ILoggingEvent> EVENT_MAP = new ConcurrentHashMap<>();
    public static final Set<String> LOG = new LinkedHashSet<>();

    @Override
    protected void append(ILoggingEvent event) {
        EVENT_MAP.put(Instant.now().toString(), event);
        LOG.add(event.getLevel().toString() +
                " | " +
                Instant.now().toString() +
                " | [" +
                event.getThreadName() +
                "] " +
                event.getFormattedMessage());
    }
}
