package io.gitlab.jfronny.inceptum.util;

import io.gitlab.jfronny.inceptum.Inceptum;
import io.gitlab.jfronny.inceptum.model.inceptum.ArtifactInfo;
import io.gitlab.jfronny.inceptum.model.mojang.VersionInfo;

import java.util.LinkedHashSet;
import java.util.Set;

public class VersionInfoLibraryResolver {
    public static Set<ArtifactInfo> getRelevant(VersionInfo version) {
        Set<ArtifactInfo> artifacts = new LinkedHashSet<>();
        for (VersionInfo.Library library : version.libraries) {
            if (library.rules != null && !library.rules.allow()) continue;
            if (library.downloads.classifiers != null && library.natives != null && library.natives.containsKey(OSCheck.OS.getMojName())) {
                artifacts.add(new ArtifactInfo(library.downloads.classifiers.get(library.natives.get(OSCheck.OS.getMojName())), true));
            }
            if (library.downloads.artifact == null) {
                Inceptum.LOGGER.info("Null library artifact @ " + library.name);
                continue;
            }
            artifacts.add(new ArtifactInfo(library.downloads.artifact, false));
        }
        return artifacts;
    }
}
