package io.gitlab.jfronny.inceptum.windows;

import io.gitlab.jfronny.inceptum.Inceptum;
import io.gitlab.jfronny.inceptum.InceptumGui;
import io.gitlab.jfronny.inceptum.install.SetupStepInfo;
import io.gitlab.jfronny.inceptum.util.api.FabricMetaApi;
import io.gitlab.jfronny.inceptum.windows.control.InstanceManageControls;

import java.io.IOException;
import java.util.concurrent.atomic.AtomicReference;

public class NewInstanceWindow extends Window {
    InstanceManageControls imc = new InstanceManageControls(null);
    public NewInstanceWindow() {
        super("New Instance");
    }

    @Override
    public void draw() {
        imc.snapshotsBox();
        imc.versionBox(ver -> {});
        //TODO forge
        imc.nameBox("OK", name -> {
            try {
                InceptumGui.open(new InstanceCreateProcessWindow(new SetupStepInfo(imc.getVersionInfo(),
                        imc.getLoaderInfo(),
                        name,
                        new AtomicReference<>("Initializing"))));
            } catch (IOException e) {
                Inceptum.LOGGER.error("Could not initialize instance creation", e);
            }
            close();
        });
    }
}
