package io.gitlab.jfronny.inceptum.gson;

import com.google.gson.*;
import io.gitlab.jfronny.inceptum.model.ComparableVersion;

import java.lang.reflect.Type;

public class ComparableVersionAdapter implements JsonDeserializer<ComparableVersion>, JsonSerializer<ComparableVersion> {
    @Override
    public ComparableVersion deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
        if (json.isJsonPrimitive() && json.getAsJsonPrimitive().isString())
            return new ComparableVersion(json.getAsString());
        else throw new JsonParseException("Expected Version to be a string");
    }

    @Override
    public JsonElement serialize(ComparableVersion src, Type typeOfSrc, JsonSerializationContext context) {
        return new JsonPrimitive(src.toString());
    }
}
