package io.gitlab.jfronny.inceptum.util;

import java.io.File;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class JvmUtils {
    public static boolean executableInPath(String executableName) {
        try {
            return java.util.stream.Stream
                    .of(System.getenv("PATH").split(java.util.regex.Pattern.quote(File.pathSeparator)))
                    .map(path -> path.replace("\"", "")).map(Paths::get)
                    .anyMatch(path -> Files.exists(path.resolve(executableName))
                            && Files.isExecutable(path.resolve(executableName)));
        } catch (Exception e) {
            return false;
        }
    }

    public static Path getJvmMain(Path jvmDir) {
        Path f = jvmDir.resolve("bin");
        Path t = f.resolve("java");
        if (!Files.exists(t)) t = f.resolve("javaw");
        if (!Files.exists(t)) t = f.resolve("java.exe");
        if (!Files.exists(t)) t = f.resolve("javaw.exe");
        return t;
    }

    public static String getJvm() {
        return getJvmMain(Path.of(System.getProperty("java.home"))).toAbsolutePath().toString();
    }
}
