package io.gitlab.jfronny.inceptum.util;

import io.gitlab.jfronny.inceptum.model.OSType;

import java.util.Locale;

public class OSCheck {
    public static final OSType OS;

    static {
        String os = System.getProperty("os.name", "generic").toLowerCase(Locale.ROOT);
        if ((os.contains("mac")) || (os.contains("darwin"))) {
            OS = OSType.MAC_OS;
        } else if (os.contains("win")) {
            OS = OSType.WINDOWS;
        } else if (os.contains("nux")) {
            OS = OSType.LINUX;
        } else {
            throw new RuntimeException("Unrecognized OS");
        }
    }
}
